#!/bin/sh
-#set -x
+[ -n "$VCSH_DEBUG" ] && set -x
+[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
+[ -z "$VCSH_BASE" ] && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
SELF=$(basename $0)
-[ -z $XDG_CONFIG_HOME ] && XDG_CONFIG_HOME="$HOME/.config"
-VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
help() {
echo "usage: $SELF <args>
- help Display this help
+ clone <remote> \\
+ [<repo>] Clone from an existing repository
+ help Display this help text
+ delete Delete an existing repository
+ enter Enter repository; spawn new $SHELL
+ init <repo> Initialize a new repository
+ list List all repositories
+ run <repo> \\
+ <command> Use this repository
+
+ seed-gitignore \\
+ <repo> Seed .gitignore.d/<repo> from git ls-files
+ setup Set up repository with recommended settings
+
+ <repo> <git command> Special command that allows you to run git commands
+ directly without having to type so much ;)" >&2
+}
- list List all repos
+debug() {
+ [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
+}
- use <repo> Use this repository
- run <repo>
- <command> Use this repository
+verbose() {
+ if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
+}
- init Initialize a new repository
- clone <remote>
- <repo> Clone from an existing repository
+fatal() {
+ echo "$SELF: fatal: $1" >&2
+ exit $2
+}
- exit Exit vcsh mode" >&2
+error() {
+ echo "$SELF: error: $1" >&2
}
-use() {
- REPO_NAME="$1"
- GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
+info() {
+ echo "$SELF: info: $1"
+}
- if [ ! -d "$GIT_DIR" ]; then
- echo E: no repository found for "$REPO_NAME" >&2
- return 2
- fi
+clone() {
+ init
+ git remote add origin "$GIT_REMOTE"
+ git config branch.master.remote origin
+ git config branch.master.merge refs/heads/master
+ git fetch
+ for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
+ [ -e "$object" ] &&
+ error "'$object' exists." &&
+ VCSH_CONFLICT=1;
+ done
+ [ "$VCSH_CONFLICT" = '1' ] &&
+ fatal "will stop after fetching and not try to merge!
+ Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
+ git merge origin/master
+}
- export GIT_DIR
- export GIT_WORK_TREE="$(git config --get core.worktree)"
- export VCSH_DIRECTORY="$REPO_NAME"
+delete() {
+ old_dir="$PWD"
+ cd "$HOME"
+ use
+ info "This operation WILL DETROY DATA!"
+ files=$(git ls-files)
+ echo "These files will be deleted:
+
+$files
+
+AGAIN, THIS WILL DELETE YOUR DATA!
+To continue, type \"Yes, do as I say\""
+ read answer
+ [ "x$answer" = "xYes, do as I say" ] || exit 16
+ for file in $files; do
+ rm -f $file || info "could not delete '$file', continuing with deletion"
+ done
+ rm -rf "$GIT_DIR" || info "could not delete '$GIT_DIR'"
+ cd "$old_dir"
+}
+
+enter() {
+ use
+ $SHELL
}
init() {
- [[ -e $GIT_DIR ]] &&
- echo "$(basename $0): fatal: $GIT_DIR exists" &&
- return 21
+ [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
export GIT_WORK_TREE="$HOME"
- mkdir -p $GIT_WORK_TREE
- cd $GIT_WORK_TREE ||
- (echo "$(basename $0): fatal: could not enter $GIT_WORK_TREE" &&
- exit 20) || exit 20
- cd $GIT_WORK_TREE
+ mkdir -p "$GIT_WORK_TREE"
+ cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
+ cd "$GIT_WORK_TREE"
git init
- git config core.worktree $GIT_WORK_TREE
+ setup
}
-leave() {
- unset GIT_DIR
- unset GIT_WORK_TREE
- unset VCSH_DIRECTORY
+list() {
+ for i in "$VCSH_BASE"/*.git; do
+ echo $(basename "$i" .git)
+ done
}
-if [ "$1" = 'help' ] || [ $# -eq 0 ]; then
- help
- [ "$1" = 'help' ]
- return $?
+run() {
+ use
+ $VCSH_EXTERNAL_COMMAND
+}
-elif [ "$1" = 'list' ]; then
- for i in $VCSH_BASE/*.git; do
- echo $(basename $i .git)
+seed_gitignore() {
+ use
+ # Switching directory as this has to be executed from $HOME to be of any use.
+ # Going back into old directory at the end in case `vcsh use` is reactivated.
+ old_dir="$PWD"
+ cd "$HOME"
+ gitignores=$(for file in $(git ls-files); do
+ while true; do
+ echo $file; new="${file%/*}"
+ [ "$file" = "$new" ] && break
+ file="$new"
+ done;
+ done | sort -u)
+ tempfile=$(mktemp) || fatal "could not create tempfile" 51
+ echo '*' > "$tempfile"
+ for gitignore in $gitignores; do
+ echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
+ [ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
done
- return 0
-
-elif [ "$1" = 'run' ]; then
- use $2
- shift 2
- "$@"
- leave
- return 0
-
-elif [ "$1" = 'use' ]; then
- if [[ -o NO_IGNORE_EOF ]]; then
- export VCSH_NO_IGNORE_EOF=1
- setopt IGNORE_EOF
- vcsh_exit() {vcsh exit; zle reset-prompt}
- zle -N vcsh_exit
- bindkey '^d' 'vcsh_exit'
+ diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
+ rm -f "$tempfile" &&
+ exit
+ if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
+ info "'$HOME/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'"
+ mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+ fatal "could not move '$HOME/.gitignore.d/$VCSH_REPO_NAME' to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
fi
- use $2
- buildPS1
- return 0
-
-elif [ "$1" = 'clone' ]; then
- export GIT_REMOTE="$2"
- export REPO_NAME="$3"
- export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
- init
-
- git remote add origin $GIT_REMOTE
- git config branch.master.remote origin
- git config branch.master.merge refs/heads/master
- git fetch
- for i in $(git ls-tree -r origin/master | awk '{print $4}'); do
- [[ -e $i ]] &&
- echo "$(basename $0): error: $i exists." &&
- CONFLICT=1;
- done
- [[ -n $CONFLICT ]] &&
- echo "$(basename $0): fatal: will stop after fetching and not try to merge!\n" &&
- exit 3
- git merge origin/master
- vcsh use $REPO_NAME
+ mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
+ fatal "could not move '$tempfile' to '$HOME/.gitignore.d/$VCSH_REPO_NAME'" 53
+ cd "$old_dir"
+}
-elif [ "$1" = 'init' ]; then
- export REPO_NAME="$2"
- export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
- init
- vcsh use $REPO_NAME
+setup() {
+ use
+ git config core.worktree "$GIT_WORK_TREE"
+ git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+ git config vcsh.vcsh 'true'
+ touch "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+ git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+}
-elif [ "$1" = 'exit' ]; then
- if [[ $VCSH_NO_IGNORE_EOF -gt 0 ]]; then
- unset VCSH_NO_IGNORE_EOF
- setopt NO_IGNORE_EOF
+use() {
+ if [ ! -d "$GIT_DIR" ]; then
+ fatal "no repository found for '$VCSH_REPO_NAME'" 12
fi
- leave
- buildPS1
- return 0
+ export GIT_WORK_TREE="$(git config --get core.worktree)"
+ export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
+if [ "$1" = 'clone' ]; then
+ [ -z $2 ] && fatal "$1: please specify a remote" 1
+ export VCSH_COMMAND="$1"
+ GIT_REMOTE="$2"
+ [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+ export VCSH_REPO_NAME
+ export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ] ||
+ [ "$1" = 'enter' ] ||
+ [ "$1" = 'init' ] ||
+ [ "$1" = 'run' ] ||
+ [ "$1" = 'seed-gitignore' ] ||
+ [ "$1" = 'setup' ]; then
+ [ -z $2 ] && fatal "$1: please specify repository to work on" 1
+ [ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
+ export VCSH_COMMAND="$1"
+ export VCSH_REPO_NAME="$2"
+ export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+ [ "$1" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$@"
+ [ "$1" = 'seed-gitignore' ] && export VCSH_COMMAND=seed_gitignore
+elif [ "$1" = 'list' ]; then
+ export VCSH_COMMAND="$1"
+elif [ -n "$1" ]; then
+ export VCSH_COMMAND=run
+ export VCSH_REPO_NAME="$1"
+ export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+ [ -d $GIT_DIR ] || { help; exit 1; }
+ shift 1
+ export VCSH_EXTERNAL_COMMAND="git $*"
else
- help
- return 3
-
+ # $1 is empty, or 'help'
+ help && exit
fi
+for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+do
+ if [ ! -d "$check_directory" ]; then
+ if [ -e "$check_directory" ]; then
+ fatal "'$check_directory' exists but is not a directory" 13
+ else
+ info "attempting to create '$check_directory'"
+ mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
+ fi
+ fi
+done
+
+verbose "$VCSH_COMMAND begin"
+$VCSH_COMMAND
+verbose "$VCSH_COMMAND end, exiting"